import processing.serial.*;

Serial port;
PFont coolFont;
String time = "";
String score = "";

int bRed = 20;
int bGreen = 0;
int bBlue = 0;
boolean inc = true;
boolean pulse = false;

void setup(){
  size(500,500);//(400,400);
  
  port = new Serial(this, "COM4", 9600);
  port.bufferUntil('*');   // delineator
  
  coolFont = loadFont("LCD2Bold-300.vlw");
  textFont(coolFont);
}

void draw(){
  background(bRed,bGreen,bBlue);  //rgb
  if(pulse)
    pulseColor();
  
  fill(255); 
  textSize(280); 
  textAlign(CENTER, BOTTOM);
  text(score, 250, 300);

  textSize(100);
  textAlign(LEFT, BOTTOM);
  text(time, 150, 450);
}

void serialEvent (Serial port){
  String data = port.readStringUntil('*');
  //data = data.substring(0, data.length());
  
  // look for,
  // time
  int index1 = data.indexOf('^');
  if(index1 > -1)
    time = data.substring(3, data.length() - 1);
    
  // score
  int index2 = data.indexOf('$');
  if(index2 > -1)
    score = data.substring(3, data.length() - 1);
    
  // alert
  int index3 = data.indexOf("30sec");
  if(index3 > -1)
    pulse = true; //pulse at 30sec mark
    
  // game over      
  int index4 = data.indexOf("gEnd");
  if(index4 > -1){
    pulse = false;
    bRed = 20;
  }

}

void pulseColor(){
  if (inc){
    if (bRed == 100)
      inc = false;
    else
      bRed += 1;
  }
  else{
    if(bRed == 20)
      inc = true;
    else
      bRed -= 1;
  }
}
